package models

import (
	"github.com/beego/beego/v2/client/orm"
	"time"
)

type CygxYanxuanSpecialApprovalLog struct {
	ApprovalLogId    int       `orm:"column(approval_log_id);pk"`
	UserId           int       // 用户ID
	CreateTime       time.Time // 创建时间
	ModifyTime       time.Time // 修改时间
	Content          string    // 内容
	Tags             string    // 标签
	ApprovalStatus   int       // 1通过、2驳回
	ImgUrl           string    // 图片链接
	DocUrl           string    // 文档链接
	Reason           string    // 理由
	Title            string    // 标题
	Type             int       // 类型1:笔记，2:观点
	CompanyTags      string    // 公司标签
	IndustryTags     string    // 行业标签
	YanxuanSpecialId int       // cygx_yanxuan_special 表主键ID
	AdminName        string    // 审核人员姓名
	AdminUserId      int       // 审核人员用户ID
	SpecialName      string    // 专栏名称
	NickName         string    // 昵称
}

func AddCygxYanxuanSpecialApprovalLog(item *CygxYanxuanSpecialApprovalLog) (err error) {
	o := orm.NewOrm()
	_, err = o.Insert(item)
	return
}
