package models

import (
	"github.com/beego/beego/v2/client/orm"
	"time"
)

type CygxMorningMeetingReviewChapterHistory struct {
	Id               int       `orm:"column(id);pk"`
	ArticleId        int       `description:"文章ID"`
	UserId           int       `description:"用户ID"`
	CreateTime       time.Time `description:"创建时间"`
	Mobile           string    `description:"手机号"`
	Email            string    `description:"邮箱"`
	CompanyId        int       `description:"公司id"`
	CompanyName      string    `description:"公司名称"`
	RealName         string    `description:"用户实际名称"`
	SellerName       string    `description:"所属销售"`
	SourcePage       string    `description:"页面来源 微信、首页、展开"`
	RegisterPlatform int       `description:"来源 1小程序，2：网页"`
	ModifyTime       time.Time `description:"更新时间"`
	MeetingId        int       `description:"晨会精华主表ID"`
}

type AddCygxMorningMeetingReviewChapterHistoryReq struct {
	Id         int    `description:"晨会精华ID"`
	SourcePage string `description:"页面来源 微信、首页、展开"`
}

// 添加历史信息
func AddCygxMorningMeetingReviewChapterHistory(item *CygxMorningMeetingReviewChapterHistory) (lastId int64, err error) {
	o := orm.NewOrm()
	item.ModifyTime = time.Now()
	lastId, err = o.Insert(item)
	return
}
