package models

import (
	"github.com/beego/beego/v2/client/orm"
	"time"
)

type CygxUserAdminShareHistory struct {
	UserAdminShareHistoryId int       `orm:"column(user_admin_share_history_id);pk";comment:"主键ID"`
	Action                  string    `comment:"动作内容"`
	UserId                  int       `comment:"用户ID"`
	Mobile                  string    `comment:"手机号"`
	Email                   string    `comment:"邮箱"`
	CompanyId               int       `comment:"公司ID"`
	CompanyName             string    `comment:"公司名称"`
	RealName                string    `comment:"用户实际名称"`
	SellerName              string    `comment:"所属销售名称"`
	SellerId                int       `comment:"所属销售ID"`
	ShareId                 int       `comment:"分享人ID"`
	ShareName               string    `comment:"分享人姓名"`
	Source                  string    `comment:"来源（article, activity, login）"`
	SourceId                int       `comment:"来源 ID"`
	SourceTitle             string    `comment:"来源名称，活动或者报告标题"`
	RegisterPlatform        int       `comment:"注册平台（1: 小程序, 2: 网页）"`
	CreateTime              time.Time `comment:"创建时间"`
	ModifyTime              time.Time `comment:"修改时间"`
}

func AddCygxUserAdminShareHistory(item *CygxUserAdminShareHistory) (err error) {
	o := orm.NewOrm()
	_, err = o.Insert(item)
	return
}
